| The Gaudi Framework v28r2p1 (f1a77ff4)

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Types | Public Member Functions | Protected Attributes | Friends | List of all members
SmartRef< TYPE > Class Template Reference

Kernel objects: SmartRef. More...

`#include <GaudiKernel/SmartRef.h>`

Collaboration diagram for SmartRef< TYPE >:
[legend]

## Public Types
enum | { VALID = StreamBuffer::VALID, INVALID = StreamBuffer::INVALID }
typedef TYPE | entry_type
| Entry type definition. More...

## Public Member Functions
| SmartRef ()
| Standard Constructor. More...
| SmartRef (TYPE *pObject)
| Standard Constructor with initialisation. More...
| SmartRef (const TYPE *pObject)
| Standard Constructor with initialisation from const object. More...
| SmartRef (const SmartRef &copy)
| Copy Constructor. More...
| SmartRef (long hint, long link, TYPE *obj=nullptr)
| Constructor. More...
| SmartRef (const ContainedObject *pObj, long hint, long link, TYPE *obj=nullptr)
| Constructor for references to contained objects passing environment. More...
| SmartRef (const DataObject *pObj, long hint, long link, TYPE *obj=nullptr)
| Constructor for references to contained objects passing environment. More...
| SmartRef (const DataObject *pObj, long hint, TYPE *obj=nullptr)
| Constructor for references to DataObjects passing environment. More...
bool | shouldFollowLink (const DataObject *) const
| Standard destructor. More...
bool | shouldFollowLink (const ContainedObject *) const
| Check if link should be followed: link must be valid and object not yet loaded. More...
long | hintID () const
| Access hint id: More...
long | linkID () const
| Access link id: More...
void | set (DataObject *pObj, long hint_id, long link_id)
| Setup smart reference when reading. Must be allowed from external sources. More...
const std::type_info * | type () const
| Access to embedded type. More...
TYPE * | data ()
| Access to raw data pointer. More...
const TYPE * | data () const
const TYPE * | target () const
| Access to the object. More...
TYPE * | target ()
| Access to the object. More...
const std::string & | path () const
| Return the path of the linked object inside the data store. More...
bool | operator== (const SmartRef< TYPE > &c) const
| Equality operator. More...
bool | operator!= (const SmartRef< TYPE > &c) const
| NON-Equality operator. More...
const SmartRef< TYPE > & | _setEnvironment (const DataObject *pObj, const ContainedObject *pContd) const
| Set the environment (CONST) More...
SmartRef< TYPE > & | _setEnvironment (const DataObject *pObj, const ContainedObject *pContd)
| Set the environment (CONST) More...
SmartRef< TYPE > & | operator() (ContainedObject *pObj)
| operator(): assigns parent object for serialisation More...
const SmartRef< TYPE > & | operator() (const ContainedObject *pObj) const
| operator() const: assigns parent object for serialisation More...
SmartRef< TYPE > & | operator() (DataObject *pObj)
| operator(): assigns parent object for serialisation More...
const SmartRef< TYPE > & | operator() (const DataObject *pObj) const
| operator() const: assigns parent object for serialisation More...
SmartRef< TYPE > & | operator= (const SmartRef< TYPE > &c)
| Assignment. More...
SmartRef< TYPE > & | operator= (TYPE *pObject)
| Assignment. More...
TYPE & | operator* ()
| Dereference operator. More...
const TYPE & | operator* () const
| Dereference operator. More...
TYPE * | operator-> ()
| Dereference operator. More...
const TYPE * | operator-> () const
| Dereference operator to const object. More...
| operator const TYPE * () const
| Implicit type conversion to const object. More...
| operator TYPE * ()
| Implicit type conversion. More...
StreamBuffer & | writeRef (StreamBuffer &s) const
| Write the reference to the stream buffer (needed due to stupid G++ compiler) More...
StreamBuffer & | readRef (StreamBuffer &s)
| Read the reference from the stream buffer (needed due to stupid G++ compiler) More...

## Protected Attributes
SmartRefBase | m_base
const TYPE * | m_target = nullptr
| Pointer to target data object. More...

## Friends
class | SmartRefArray< TYPE >
| The container must be a friend. More...
class | SmartRefList< TYPE >
class | SmartRefMap< TYPE >
StreamBuffer & | operator<< (StreamBuffer &_s, const SmartRef< TYPE > &ptr)
| Output Streamer operator. More...
StreamBuffer & | operator>> (StreamBuffer &_s, SmartRef< TYPE > &ptr)
| Input Streamer operator. More...

## Detailed Description

### template<class TYPE>
class SmartRef< TYPE >

Kernel objects: SmartRef.

Description: The SmartRef class allows transparent handling of object links within the data store. Links are unloaded a priori and will only be loaded "on demand", i.e. when dereferenced.

SmartRefs should behave in the same way as normal pointers; The SmartRef object in fact is a smart pointer construct intercepting the dereference operators.

When loading, the executed code resides in the non templated base class. This ensures, that the templated code is minimized and code blow up is inhibited.

Using SmartRefs StreamBuffers are able to also save the references on data conversion requests.

Base Class: SmartRefBase

Dependencies:

- Base class: GaudiKernel/SmartRefBase.h

History :

    +---------+----------------------------------------------+--------+
    |    Date |                 Comment                      | Who    |
    +---------+----------------------------------------------+--------+
    | 21/04/99| Initial version.                             | MF     |
    | 16/01/04| Move base class into aggregation.            | MF     |
    +---------+----------------------------------------------+--------+

Author: M.Frank Version: 1.0

Definition at line 62 of file SmartRef.h.

## Member Typedef Documentation

template<class TYPE>

typedef TYPE SmartRef< TYPE >::entry_type

Entry type definition.

Definition at line 71 of file SmartRef.h.

## Member Enumeration Documentation

template<class TYPE>

anonymous enum

Enumerator
VALID |
INVALID |

Definition at line 69 of file SmartRef.h.

69 { VALID = StreamBuffer::VALID, INVALID = StreamBuffer::INVALID };
SmartRef::VALID
Definition: SmartRef.h:69
StreamBuffer::VALID
Definition: StreamBuffer.h:117
StreamBuffer::INVALID
Definition: StreamBuffer.h:117
SmartRef::INVALID
Definition: SmartRef.h:69

## Constructor & Destructor Documentation

template<class TYPE>

SmartRef< TYPE >::SmartRef | ( |  | ) |
| inline

Standard Constructor.

Definition at line 78 of file SmartRef.h.

78 {
79 m_base.m_hintID = INVALID;
80 m_base.m_linkID = INVALID;
81 _setEnvironment(0, 0);
82 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
SmartRef::INVALID
Definition: SmartRef.h:69
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | TYPE * | pObject | ) |
| inline

Standard Constructor with initialisation.

Definition at line 84 of file SmartRef.h.

84 {
85 m_base.m_hintID = INVALID;
86 m_base.m_linkID = INVALID;
87 m_target = pObject;
88 _setEnvironment(0, 0);
89 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
SmartRef::INVALID
Definition: SmartRef.h:69
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const TYPE * | pObject | ) |
| inline

Standard Constructor with initialisation from const object.

Definition at line 91 of file SmartRef.h.

91 {
92 m_base.m_hintID = INVALID;
93 m_base.m_linkID = INVALID;
94 m_target = const_cast<TYPE*>(pObject);
95 _setEnvironment(0, 0);
96 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
SmartRef::INVALID
Definition: SmartRef.h:69
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const SmartRef< TYPE > & | copy | ) |
| inline

Copy Constructor.

Definition at line 98 of file SmartRef.h.

98 {
99 m_base.m_hintID = copy.m_base.m_hintID;
100 m_base.m_linkID = copy.m_base.m_linkID;
101 m_target = copy.m_target;
102 _setEnvironment(copy.m_base.m_data, copy.m_base.m_contd);
103 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:56
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | long | hint,
|  | long | link,
|  | TYPE * | obj = `nullptr`
| ) |  |
| inline

Constructor.

Definition at line 105 of file SmartRef.h.

105 {
106 m_base.m_hintID = hint;
107 m_base.m_linkID = link;
108 m_target = obj;
109 _setEnvironment(0, 0);
110 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const ContainedObject * | pObj,
|  | long | hint,
|  | long | link,
|  | TYPE * | obj = `nullptr`
| ) |  |
| inline

Constructor for references to contained objects passing environment.

Definition at line 112 of file SmartRef.h.

112 {
113 m_base.m_hintID = hint;
114 m_base.m_linkID = link;
115 m_target = obj;
116 const DataObject* src = (0==pObj) ? 0 : pObj->parent();
117 _setEnvironment(src, pObj);
118 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
ContainedObject::parent
const ObjectContainerBase * parent() const
Access to parent object.
Definition: ContainedObject.h:49
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:30
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const DataObject * | pObj,
|  | long | hint,
|  | long | link,
|  | TYPE * | obj = `nullptr`
| ) |  |
| inline

Constructor for references to contained objects passing environment.

Definition at line 120 of file SmartRef.h.

120 {
121 m_base.m_hintID = hint;
122 m_base.m_linkID = link;
123 m_target = obj;
124 _setEnvironment(pObj, 0);
125 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
template<class TYPE>

SmartRef< TYPE >::SmartRef | ( | const DataObject * | pObj,
|  | long | hint,
|  | TYPE * | obj = `nullptr`
| ) |  |
| inline

Constructor for references to DataObjects passing environment.

Definition at line 127 of file SmartRef.h.

127 {
128 m_base.m_hintID = hint;
129 m_base.m_linkID = INVALID;
130 m_target = obj;
131 _setEnvironment(pObj, 0);
132 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
SmartRef::INVALID
Definition: SmartRef.h:69

## Member Function Documentation

template<class TYPE>

const SmartRef<TYPE>& SmartRef< TYPE >::_setEnvironment | ( | const DataObject * | pObj,
|  | const ContainedObject * | pContd
| ) |  | const
| inline

Set the environment (CONST)

Definition at line 186 of file SmartRef.h.

186 {
187 m_base.m_data = pObj;
188 m_base.m_contd = pContd;
189 m_base.setObjectType(data());
190 return *this;
191 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::setObjectType
void setObjectType(const ContainedObject *) const
Definition: SmartRefBase.h:100
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:56
SmartRef::data
TYPE * data()
Access to raw data pointer.
Definition: SmartRef.h:161
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::_setEnvironment | ( | const DataObject * | pObj,
|  | const ContainedObject * | pContd
| ) |  |
| inline

Set the environment (CONST)

Definition at line 193 of file SmartRef.h.

193 {
194 m_base.m_data = pObj;
195 m_base.m_contd = pContd;
196 m_base.setObjectType(data());
197 return *this;
198 }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::setObjectType
void setObjectType(const ContainedObject *) const
Definition: SmartRefBase.h:100
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:56
SmartRef::data
TYPE * data()
Access to raw data pointer.
Definition: SmartRef.h:161
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
template<class TYPE>

TYPE* SmartRef< TYPE >::data | ( |  | ) |
| inline

Access to raw data pointer.

Definition at line 161 of file SmartRef.h.

161 {
162 return const_cast<TYPE*>(m_target);
163 }
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
template<class TYPE>

const TYPE* SmartRef< TYPE >::data | ( |  | ) | const
| inline

Definition at line 164 of file SmartRef.h.

164 {
165 return m_target;
166 }
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
template<class TYPE>

long SmartRef< TYPE >::hintID | ( |  | ) | const
| inline

Access hint id:

Definition at line 145 of file SmartRef.h.

145 {
146 return m_base.m_hintID;
147 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
template<class TYPE>

long SmartRef< TYPE >::linkID | ( |  | ) | const
| inline

Access link id:

Definition at line 149 of file SmartRef.h.

149 {
150 return m_base.m_linkID;
151 }
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
template<class TYPE>

SmartRef< TYPE >::operator const TYPE * | ( |  | ) | const
| inline

Implicit type conversion to const object.

Definition at line 239 of file SmartRef.h.

239 { return SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:278
template<class TYPE>

SmartRef< TYPE >::operator TYPE * | ( |  | ) |
| inline

Implicit type conversion.

Definition at line 241 of file SmartRef.h.

241 { return SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:278
template<class TYPE>

bool SmartRef< TYPE >::operator!= | ( | const SmartRef< TYPE > & | c | ) | const
| inline

NON-Equality operator.

Definition at line 182 of file SmartRef.h.

182 {
183 return !(this->operator==(c));
184 }
SmartRef::operator==
bool operator==(const SmartRef< TYPE > &c) const
Equality operator.
Definition: SmartRef.h:174
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::operator() | ( | ContainedObject * | pObj | ) |
| inline

operator(): assigns parent object for serialisation

Definition at line 200 of file SmartRef.h.

200 {
201 const DataObject* src = ( pObj ? pObj->parent() : nullptr );
202 return _setEnvironment(src, pObj);
203 }
ContainedObject::parent
const ObjectContainerBase * parent() const
Access to parent object.
Definition: ContainedObject.h:49
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:30
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
template<class TYPE>

const SmartRef<TYPE>& SmartRef< TYPE >::operator() | ( | const ContainedObject * | pObj | ) | const
| inline

operator() const: assigns parent object for serialisation

Definition at line 205 of file SmartRef.h.

205 {
206 const DataObject* src = ( pObj ? pObj->parent() : nullptr );
207 return _setEnvironment(src, pObj);
208 }
ContainedObject::parent
const ObjectContainerBase * parent() const
Access to parent object.
Definition: ContainedObject.h:49
DataObject
A DataObject is the base class of any identifiable object on any data store.
Definition: DataObject.h:30
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::operator() | ( | DataObject * | pObj | ) |
| inline

operator(): assigns parent object for serialisation

Definition at line 210 of file SmartRef.h.

210 {
211 return _setEnvironment(pObj,nullptr);
212 }
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
template<class TYPE>

const SmartRef<TYPE>& SmartRef< TYPE >::operator() | ( | const DataObject * | pObj | ) | const
| inline

operator() const: assigns parent object for serialisation

Definition at line 214 of file SmartRef.h.

214 {
215 return _setEnvironment(pObj,nullptr);
216 }
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
template<class TYPE>

TYPE& SmartRef< TYPE >::operator* | ( |  | ) |
| inline

Dereference operator.

Definition at line 231 of file SmartRef.h.

231 { return *SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:278
template<class TYPE>

const TYPE& SmartRef< TYPE >::operator* | ( |  | ) | const
| inline

Dereference operator.

Definition at line 233 of file SmartRef.h.

233 { return *SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:278
template<class TYPE>

TYPE* SmartRef< TYPE >::operator-> | ( |  | ) |
| inline

Dereference operator.

Definition at line 235 of file SmartRef.h.

235 { return SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:278
template<class TYPE>

const TYPE* SmartRef< TYPE >::operator-> | ( |  | ) | const
| inline

Dereference operator to const object.

Definition at line 237 of file SmartRef.h.

237 { return SmartRef<TYPE>::target(); }
SmartRef::target
const TYPE * target() const
Access to the object.
Definition: SmartRef.h:278
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::operator= | ( | const SmartRef< TYPE > & | c | ) |
| inline

Assignment.

Definition at line 218 of file SmartRef.h.

218 {
219 m_target = c.m_target;
220 m_base.m_hintID = c.m_base.m_hintID;
221 m_base.m_linkID = c.m_base.m_linkID;
222 return _setEnvironment(c.m_base.m_data, c.m_base.m_contd); }
SmartRefBase::m_data
const DataObject * m_data
Object data: Pointer to the identifiable object the link originates.
Definition: SmartRefBase.h:54
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRefBase::m_contd
const ContainedObject * m_contd
Object data: Pointer to the Contained object (if applicable)
Definition: SmartRefBase.h:56
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::_setEnvironment
const SmartRef< TYPE > & _setEnvironment(const DataObject *pObj, const ContainedObject *pContd) const
Set the environment (CONST)
Definition: SmartRef.h:186
template<class TYPE>

SmartRef<TYPE>& SmartRef< TYPE >::operator= | ( | TYPE * | pObject | ) |
| inline

Assignment.

Definition at line 224 of file SmartRef.h.

224 {
225 m_target = pObject;
226 m_base.m_hintID = INVALID;
227 m_base.m_linkID = INVALID;
228 return *this;
229 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::INVALID
Definition: SmartRef.h:69
template<class TYPE>

bool SmartRef< TYPE >::operator== | ( | const SmartRef< TYPE > & | c | ) | const
| inline

Equality operator.

Definition at line 174 of file SmartRef.h.

174 {
175 if ( m_target && c.m_target ) return m_target == c.m_target;
176 if ( !m_target && !c.m_target ) return m_base.isEqual(m_target,c.m_base);
177 if ( m_target && !c.m_target ) return m_base.isEqualEx(m_target, c.m_base);
178 if ( !m_target && c.m_target ) return c.m_base.isEqualEx(c.m_target, m_base);
179 return false;
180 }
SmartRefBase::isEqual
bool isEqual(const ContainedObject *, const SmartRefBase &c) const
Equality operator for ContainedObject like references.
Definition: SmartRefBase.h:72
SmartRefBase::isEqualEx
bool isEqualEx(const DataObject *pObj, const SmartRefBase &c) const
Extended equality check.
Definition: SmartRefBase.cpp:69
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
template<class TYPE>

const std::string& SmartRef< TYPE >::path | ( |  | ) | const
| inline

Return the path of the linked object inside the data store.

Definition at line 172 of file SmartRef.h.

172 { return m_base.path(); }
SmartRefBase::path
const std::string & path() const
Shortcut to access the path to the linked object.
Definition: SmartRefBase.cpp:91
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
template<class TYPE >

StreamBuffer & SmartRef< TYPE >::readRef | ( | StreamBuffer & | s | ) |
| inline

Read the reference from the stream buffer (needed due to stupid G++ compiler)

Definition at line 294 of file SmartRef.h.

294 {
295 m_target = dynamic_cast<TYPE*>( m_base.readObject(m_target, s) );
296 return s;
297 }
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
gaudirun.s
string s
Definition: gaudirun.py:245
SmartRefBase::readObject
DataObject * readObject(const DataObject *, StreamBuffer &s) const
Input streamer for DataObject like references.
Definition: SmartRefBase.h:89
template<class TYPE>

void SmartRef< TYPE >::set | ( | DataObject * | pObj,
|  | long | hint_id,
|  | long | link_id
| ) |  |
| inline

Setup smart reference when reading. Must be allowed from external sources.

Definition at line 153 of file SmartRef.h.

153 {
154 m_base.set(pObj, hint_id, link_id);
155 }
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRefBase::set
void set(DataObject *pObj, long hint_id, long link_id)
Setup smart reference when reading. Must be allowed from external sources.
Definition: SmartRefBase.cpp:26
template<class TYPE>

bool SmartRef< TYPE >::shouldFollowLink | ( | const DataObject * |  | ) | const
| inline

Standard destructor.

Check if link should be followed: link must be valid and object not yet loaded

Definition at line 137 of file SmartRef.h.

137 {
138 return (!m_target && m_base.m_hintID != INVALID );
139 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRef::INVALID
Definition: SmartRef.h:69
template<class TYPE>

bool SmartRef< TYPE >::shouldFollowLink | ( | const ContainedObject * |  | ) | const
| inline

Check if link should be followed: link must be valid and object not yet loaded.

Definition at line 141 of file SmartRef.h.

141 {
142 return (!m_target && m_base.m_hintID != INVALID && m_base.m_linkID != INVALID );
143 }
SmartRefBase::m_hintID
long m_hintID
Object data: ID of the link hint to the identifiable object.
Definition: SmartRefBase.h:50
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
SmartRefBase::m_linkID
long m_linkID
Object data: ID of the object within the identifiable container (if any)
Definition: SmartRefBase.h:52
SmartRef::INVALID
Definition: SmartRef.h:69
template<class TYPE >

const TYPE * SmartRef< TYPE >::target | ( |  | ) | const
| inline

Access to the object.

Access to the object (CONST)

Definition at line 278 of file SmartRef.h.

278 {
279 if ( !m_target ) {
280 m_target = dynamic_cast<const TYPE*>(m_base.accessData(m_target));
281 }
282 return m_target;
283 }
SmartRefBase::accessData
const ContainedObject * accessData(const ContainedObject *typ) const
Load on demand of ContainedObject like references.
Definition: SmartRefBase.cpp:33
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
template<class TYPE >

TYPE * SmartRef< TYPE >::target | ( |  | ) |
| inline

Access to the object.

Definition at line 269 of file SmartRef.h.

269 {
270 if ( !m_target ) {
271 m_target = dynamic_cast<const TYPE*>(m_base.accessData(m_target));
272 }
273 return const_cast<TYPE*>(m_target);
274 }
SmartRefBase::accessData
const ContainedObject * accessData(const ContainedObject *typ) const
Load on demand of ContainedObject like references.
Definition: SmartRefBase.cpp:33
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
template<class TYPE>

const std::type_info* SmartRef< TYPE >::type | ( |  | ) | const
| inline

Access to embedded type.

Definition at line 157 of file SmartRef.h.

157 {
158 return &typeid(TYPE);
159 }
template<class TYPE >

StreamBuffer & SmartRef< TYPE >::writeRef | ( | StreamBuffer & | s | ) | const
| inline

Write the reference to the stream buffer (needed due to stupid G++ compiler)

Definition at line 287 of file SmartRef.h.

287 {
288 m_base.writeObject(m_target, s);
289 return s;
290 }
SmartRefBase::writeObject
void writeObject(const DataObject *pObject, StreamBuffer &s) const
Output streamer for DataObject like references.
Definition: SmartRefBase.h:81
SmartRef::m_base
SmartRefBase m_base
Definition: SmartRef.h:73
SmartRef::m_target
const TYPE * m_target
Pointer to target data object.
Definition: SmartRef.h:75
gaudirun.s
string s
Definition: gaudirun.py:245

## Friends And Related Function Documentation

template<class TYPE>

StreamBuffer& operator<< | ( | StreamBuffer & | _s,
|  | const SmartRef< TYPE > & | ptr
| ) |  |
| friend

Output Streamer operator.

Definition at line 248 of file SmartRef.h.

248 {
249 return ptr.writeRef(_s);
250 }
SmartRef::writeRef
StreamBuffer & writeRef(StreamBuffer &s) const
Write the reference to the stream buffer (needed due to stupid G++ compiler)
Definition: SmartRef.h:287
template<class TYPE>

StreamBuffer& operator>> | ( | StreamBuffer & | _s,
|  | SmartRef< TYPE > & | ptr
| ) |  |
| friend

Input Streamer operator.

Definition at line 253 of file SmartRef.h.

253 {
254 return ptr.readRef(_s);
255 }
SmartRef::readRef
StreamBuffer & readRef(StreamBuffer &s)
Read the reference from the stream buffer (needed due to stupid G++ compiler)
Definition: SmartRef.h:294
template<class TYPE>

friend class SmartRefArray< TYPE >
| friend

The container must be a friend.

Definition at line 64 of file SmartRef.h.

template<class TYPE>

friend class SmartRefList< TYPE >
| friend

Definition at line 65 of file SmartRef.h.

template<class TYPE>

friend class SmartRefMap< TYPE >
| friend

Definition at line 66 of file SmartRef.h.

## Member Data Documentation

template<class TYPE>

SmartRefBase SmartRef< TYPE >::m_base
| protected

Definition at line 73 of file SmartRef.h.

template<class TYPE>

const TYPE* SmartRef< TYPE >::m_target = nullptr
| mutable protected

Pointer to target data object.

Definition at line 75 of file SmartRef.h.

The documentation for this class was generated from the following file:

- GaudiKernel/GaudiKernel/SmartRef.h